// load feed
$('#feed-show-page').live('pageshow', function(event) {
    var $activePage = $.mobile.activePage

    // only load if there are no results
    var $resultList = $activePage.find('#results')
    if ( $resultList.children().size() > 0 ) return

    $.mobile.showPageLoadingMsg()

    var requestUrl = "/app/Feed/async_results"    
    $resultList.load(requestUrl, function(){
        $.mobile.hidePageLoadingMsg()
        adjustShowMore($activePage)
        $resultList.listview("refresh").trigger("updatelayout")
    })
})

function adjustShowMore($activePage) {
    // look for end of list <li>
    $eol = $activePage.find('li#eol')
    $showMore = $activePage.find('li.#show-more-earlier')
    if ( $eol.size() > 0 ) {
        $eol.remove()
        $showMore.hide()
    } else {
        $showMore.show()
    }    
}

function feedShowMoreEarlier() {
    $.mobile.showPageLoadingMsg()
    
    var $activePage = $.mobile.activePage
    var $resultList = $activePage.find('#results')
    var requestUrl = "/app/Feed/async_earlier"
    
    $.get(requestUrl, function(result){
        $.mobile.hidePageLoadingMsg()
        $resultList.append(result)
        adjustShowMore($activePage)
        $resultList.listview("refresh").trigger("updatelayout")
    })    
}

$('#feed-show-page a[rel="external"]').live('click', function(event) {
    // navigation to a feed link. ensure page is reloaded upon return
    // note some times JQM reloads on its own, but not always :(
    // jqm pageshow event doesn't fire in this case
    window.addEventListener('pageshow', function() {
        var requestUrl = "/app/Feed/clear_controls"
        $.get(requestUrl)
        $.mobile.fixedToolbars.show()
        $.mobile.activePage.trigger("updatelayout")
    }, false)
})

$('#feed-show-page,#feed-show-search-page').live('pageremove', function(e) {
    if ($.mobile.activePage.attr('id').indexOf("feed-") == 0){
        // Don't remove unless navigation is away from Directory
        e.preventDefault()
    }
})

// Search

$('#feed-show-search-page #feed-search-form').live('submit', function() {    
    feed_search()        
    return false
})

var feedKeywords = null
var feedFeedNames = null
var feedStartDate = null
var feedEndDate = null

function feed_search() {
    // kill keyboard
    if( window.document.activeElement ){
    	$( window.document.activeElement || "" ).add( "input:focus, textarea:focus, select:focus" ).blur();
    }

    var $activePage = $.mobile.activePage

    var feedKeywords = $activePage.find("#keywords").val() || null	
	var feedFeedNames = $activePage.find("#feeds").val() || null		
    var feedStartDate = $activePage.find("#startDate").val() || null
    var feedEndDate = $activePage.find("#endDate").val() || null
    
    // store search filter in controller
    var requestUrl = "/app/Feed/set_search_filter"
    var requestData = {}
    if (feedKeywords) requestData["keywords"] = feedKeywords
    if (feedFeedNames) requestData["feed-names"] = feedFeedNames.toString()
    if (feedStartDate) requestData["start-date"] = feedStartDate
    if (feedEndDate) requestData["end-date"] = feedEndDate
    $.get(requestUrl, requestData)
    
    // empty current results, and return to show feed
   	$('#feed-show-page #results').empty()
    history.back()
}
function clear_search() {
    var $activePage = $.mobile.activePage
    $activePage.find('#keywords').val("")
    var $feeds = $activePage.find('#feeds')
    $feeds.find('option:selected').removeAttr('selected')
    $feeds.selectmenu('refresh')
    $activePage.find('#startDate').val("")
    $activePage.find('#endDate').val("")
    // now do the search with it all cleared
    feed_search()
}

$("#feed-show-search-page #search-feed").live('click', function() {		
	feed_search()
})

$("#feed-show-search-page #clear-search").live('click', function() {		
	clear_search()
})
//###############Start SCU custom code#################
//#  Loads up feed_custom.js so that it can be used   #
//#  by show.erb									  #
//#####################################################
var fileref = document.createElement('script')
fileref.setAttribute("type","text/javascript")
fileref.setAttribute("src", "/app/Feed/js/feed_custom.js")
document.getElementsByTagName("head")[0].appendChild(fileref)
//################End SCU custom code##################