//#############################################
//feed_custom.js overides the <div id="summary">
//Tag so that it shows a menu allowing filters to 
//be applied to the search
//#############################################

//#############################################
//Global variable selectedFeeds asociative 
//array object to hold all the selected filter
//options.
//#############################################
var selectedFeeds = new Object();

//#############################################
//Global variable feedSelectedColor is the color
//of the text once a feed button is selected
//rgb(0,128,0) is green
//#############################################
var feedSelectedColor = "rgb(0, 128, 0)"; 

//#############################################
//Global variable feedDeselectedColor is the color
//of the text once a feed button is deselected
//rgb(255,255,255) is white
//#############################################
var feedDeselectedColor = "rgb(255,255,255)";
	
//#############################################
//Attaches a click event litener to $(#summary)
//once the feed-show-page is loaded
//#############################################
$('#feed-show-page #summary').live('click', function(event) {
	attachFilterClickListener();
});

//#############################################
//shows the filter menu
//#############################################
function attachFilterClickListener(){
	$("#filter").slideDown();
	$("#menu").slideUp();
}

//#############################################
//takes the associative array of all selected 
//objects and turns it into an array of strings.
//calls the refreshPage() method to load up
//the changes
//#############################################
function applyFilter(){
	$("#filter").slideUp();
	$("#menu").slideDown();
	var feeds = new Array()
	for(var pick in selectedFeeds)
	{
		feeds.push(pick);
	}
	if(feeds.length>0){
	refreshPage(feeds);
	}
}

//#############################################
//checks the currently selected feed, if it is 
//already selected it changes the color of the 
//text to white and removes it from the 
//selectedFeeds associative array, if it is
//not selected it changes the color to green
//and adds it to the selectedFeeds associative 
//array
//#############################################
function toggleFeed(feedName){
var currentColor = $(feedName).css("color");
if(currentColor == feedSelectedColor){
$(feedName).css("color", feedDeselectedColor);	
delete selectedFeeds[$(feedName).text()];
}else{
	$(feedName).css("color", feedSelectedColor);	
	selectedFeeds[$(feedName).text()] = $(feedName).text();
}
}

//#############################################
//Refreshes the page with the filters applied
//#############################################
function refreshPage(feeds){
	//#############################################
	//Applies the filter to the set_search_filter
	//controller so that when the page is reloaded
	//all the filters are applied
	//#############################################
    var requestUrl = "/app/Feed/set_search_filter" 
   	var searchdata = new Object();
   	searchdata['feed-names'] = feeds[0];
   	for(var i = 1; i < feeds.length; i++){
   		searchdata['feed-names'] += "," +feeds[i];
   	}
    $.get(requestUrl, searchdata)
    //#############################################
    //clears the current list of feeds and refreshes
    //the page with the new results
    //#############################################
	$('#feed-show-page #results').empty();
    var $activePage = $.mobile.activePage
    var $resultList = $activePage.find('#results')
    $.mobile.showPageLoadingMsg()
    var requestRefreshUrl = "/app/Feed/async_results"    
    $resultList.load(requestRefreshUrl, function(){
        $.mobile.hidePageLoadingMsg()
        adjustShowMore($activePage)
        $resultList.listview("refresh").trigger("updatelayout")
    })
}