$('#grades-show-page').live('pageshow', function(event) {
    var $activePage = $.mobile.activePage
    
    // bind for term select change
    var $selectTerm = $activePage.find('select#terms')
    $selectTerm.bind('change', function() {
        var termId = $(this).val()
        loadGrades( { termId: termId } )
    })
    
    $leftArrow = $activePage.find('a#left-arrow')
    $leftArrow.bind('click', function() {
        var termId = $selectTerm.val()
        loadGrades( { termId: termId, previousTerm: true } )
    })
    $rightArrow = $activePage.find('a#right-arrow')
    $rightArrow.bind('click', function() {
        var termId = $selectTerm.val()
        loadGrades( { termId: termId, nextTerm: true } )
    })    

    // load if grades aren't already there
    var $gradesList = $activePage.find('ul#grades-list')
    if ( $gradesList.children().size() > 1 ) return

    var termId = $selectTerm.val()
    loadGrades( { termId: termId } )
})

function loadGrades(argMap /*{termId:null, previousTerm:false, nextTerm:false}*/) {
    argMap = argMap || {}
    argMap.termId = argMap.termId || null
    argMap.previousTerm = argMap.previousTerm || false
    argMap.nextTerm = argMap.nextTerm || false
    var $activePage = $.mobile.activePage
    
    $.mobile.showPageLoadingMsg()

    var requestUrl = "/app/Grades/async_grades"
    var requestData = {}
    if ( argMap.termId ) requestData['termId'] = argMap.termId
    requestData['previousTerm'] = argMap.previousTerm
    requestData['nextTerm'] = argMap.nextTerm
    loadGradesRequest(requestUrl, requestData)
}

function loadGradesRequest(requestUrl, requestData) {
    var $activePage = $.mobile.activePage
    var $gradesList = $activePage.find('ul#grades-list')
    $.get(requestUrl, requestData, function(result){
        $.mobile.hidePageLoadingMsg()
        $gradesList.find('li#grade').remove()
        $gradesList.append(result)
        $gradesList.listview("refresh").trigger("updatelayout")
        updateTermNavigation()
    })    
}

function updateTermNavigation() {
    var $activePage = $.mobile.activePage
    var url = "/app/Grades/get_grade_request_json"
    $.getJSON( url, function(resultJson) {
        $leftArrow = $activePage.find('a#left-arrow')
        if (resultJson.previousTerm)
            $leftArrow.show()
        else
            $leftArrow.hide()

        $rightArrow = $activePage.find('a#right-arrow')
        if (resultJson.nextTerm)
            $rightArrow.show()
        else
            $rightArrow.hide()
        
        var $selectTerm = $activePage.find('select#terms')
        $selectTerm.val(resultJson.termId)
        $selectTerm.selectmenu('refresh')
    })
}