$('#schedule-show-schedule-page').live('pageinit updatelayout', function(event) {
    var $schedulePage = $('#schedule-show-schedule-page')
    $schedulePage.find('.extraContent').hide()
    // expand/collapse
    $schedulePage.find('.itemContainer').toggle(
        function() {
            // wrap data
            var $this = $(this)
            $this.children("h3").css({
                "overflow": "visible",
                "white-space": "normal"
            })
            $this.children("p").children(".locationLink").css({
                "overflow": "visible",
                "white-space": "normal"
            })
            $.mobile.fixedToolbars.show(false)
            // expand
            $this.children(".extraContent").slideDown(300, function() {
                $.mobile.fixedToolbars.show(true)
            })
            $this.addClass("open")
        },
        function() {
            // truncate data
            var $this = $(this)
            $this.children("h3").css({
                "white-space": "nowrap",
                "overflow": "hidden",
                "text-overflow": "ellipsis"
            })
            $this.children("p").children(".locationLink").css({
                "white-space": "nowrap",
                "overflow": "hidden",
                "text-overflow": "ellipsis"
            })
            $.mobile.fixedToolbars.show(false)
            // collapse
            $this.children(".extraContent").slideUp(300, function() {
                $.mobile.fixedToolbars.show(true)
            })
            $this.removeClass("open")
        }
    )
})

$('#schedule-show-schedule-page').live('pagebeforeshow', function(event) {
    var $schedulePage = $('#schedule-show-schedule-page')

    // clean up Show More buttons
    $schedulePage.find('li[id|="show-more"] div.ui-btn-inner span').remove()
    $schedulePage.find('li[id|="show-more"] div.ui-btn-text').css('text-align', 'center')
})

$('#schedule-show-schedule-page').live('pageshow', function(event) {
    var $schedulePage = $('#schedule-show-schedule-page')

    // scroll up to hide show-more-earlier
    var headerHeight = $schedulePage.find(':jqmData(role="header")').height()
    var $listDividers = $schedulePage.find('#schedule-list :jqmData(role="list-divider")')
    if ( $listDividers.size() > 0){
        var dividerTop = $listDividers.first().offset().top
        $.mobile.silentScroll(dividerTop-headerHeight)
        $schedulePage.trigger('updatelayout')    
    }
})

function scheduleParseIso8601Date( dateString ) {
    dateParts = dateString.split('-')
    return new Date(dateParts[0], +dateParts[1] - 1, dateParts[2])
}

function scheduleToIso8601String( theDate ) {
    var year = theDate.getFullYear().toString()
    var month = (theDate.getMonth() + 1).toString()
    var date = theDate.getDate().toString()
    
    if (month.length == 1) month = "0"+month
    if (date.length == 1) date = "0"+date

    return year+"-"+month+"-"+date
}

var scheduleStartDate = null, scheduleEndDate = null
$('#schedule-show-schedule-page').live("pageinit", function(event) {
    scheduleStartDate = scheduleParseIso8601Date($('#start-date').val())
    scheduleEndDate = scheduleParseIso8601Date($('#end-date').val())
})

function scheduleDateAdd( theDate, dayOffset ){
    newDate = new Date(theDate)
    newDate.setDate(newDate.getDate() + dayOffset )
    
    return newDate
}

function scheduleLoadEarlier(){
    var startDate = scheduleDateAdd( scheduleStartDate, -8)
    var endDate = scheduleDateAdd( scheduleStartDate, -1)
    scheduleLoad(startDate, endDate, true)
    scheduleStartDate = startDate
}

function scheduleLoadLater(){
    var startDate = scheduleDateAdd( scheduleEndDate, 1)
    var endDate = scheduleDateAdd( scheduleEndDate, 8)
    scheduleLoad(startDate, endDate, false)
    scheduleEndDate = endDate
}

function scheduleLoad(startDate, endDate, earlier){
    $.mobile.showPageLoadingMsg()

    var $activePage = $.mobile.activePage
    var scheduleList = $activePage.find('#schedule-list')
    var showMoreEarlierItem = $activePage.find('#show-more-earlier')
    var showMoreLaterItem = $activePage.find('#show-more-later')
    
    var requestUrl = "/app/Schedule/inline_retrieve_schedule"
    var requestData = { "start-date": scheduleToIso8601String(startDate), "end-date": scheduleToIso8601String(endDate) }
    
    $.get(requestUrl, requestData, function(result){
        $.mobile.hidePageLoadingMsg()
        var oldFirstDivider = showMoreEarlierItem.next()
        var scrollTopOffset = oldFirstDivider.offset().top - $(window).scrollTop()
        if ( earlier ) {
            showMoreEarlierItem.after(result)
        } else {
            showMoreLaterItem.before(result)
        }
        
        // enhance the new <li>s
        scheduleList.listview("refresh")
        
        if (earlier) {
            // adjust top so the new items need to be scrolled to see
            var oldFirstDividerCurrentTop = oldFirstDivider.offset().top,
                newScrollTop = oldFirstDividerCurrentTop - scrollTopOffset
            $.mobile.silentScroll(newScrollTop)
        }
        
        scheduleList.trigger('updatelayout')
    }) 
}

function calendarLoad(startDate)
{
    var requestUrl = "/app/Schedule/show_set_schedule?start-date=" + startDate
    $.mobile.changePage(requestUrl);
}

$('#schedule-show-calendar-page').live('pagecreate', function(event) {            
    $('#mydate').bind('change', function () {
        var startDate = calendarDate = $('#mydate').val()
        calendarLoad(startDate)
    });
});